Index: resources/styles/default/lines
===================================================================
--- resources/styles/default/lines	(revision 4255)
+++ resources/styles/default/lines	(working copy)
@@ -17,21 +17,21 @@
 highway=* & name=* {set mkgmap:street='${name}'}
 
 # Mark highways with the toll flag
-highway=* & (toll=yes|toll=true) {set mkgmap:toll=yes}
+highway=* & (toll=yes | toll=true) {set mkgmap:toll=yes}
 
 # mark multipolygons as area
 highway=* & mkgmap:mp_created=true {add area=yes}
 
 # Hide proposed ways
-(highway=proposed | highway=proposal | highway=planned | highway~'.*proposed.*') {delete highway; delete junction}
+highway=proposed | highway=proposal | highway=planned | highway~'.*proposed.*' {delete highway; delete junction}
 # Hide removed ways
-(highway=razed | highway=dismantled) {deletealltags}
+highway=razed | highway=dismantled {deletealltags}
 # Hide abandoned ways. Abandoned highways have some evidence of their former existence but are no longer used. These
 # abandoned highways could be useful in topographical maps.
 # https://wiki.openstreetmap.org/wiki/Key:abandoned:
-((abandoned:highway=* & highway!=*) | highway=abandoned) {deletealltags}
+(abandoned:highway=* & highway!=*) | highway=abandoned {deletealltags}
 # Hide other non-existent ways
-(highway=unbuilt | highway=neverbuilt | highway=rejected | highway~'x-.*') {delete highway; delete junction}
+highway=unbuilt | highway=neverbuilt | highway=rejected | highway~'x-.*' {delete highway; delete junction}
 # Remove highway tag from ways which are not suitable for routing
 highway=traffic_signals | highway=junction | highway=island | highway=centre_line | highway=traffic_island | highway=stopline
     {delete highway}
@@ -41,7 +41,7 @@
 # Hide unaccessible tunnels
 highway=* & tunnel=yes & (access=private | access=no) & foot!=* & bicycle!=* {delete highway; delete junction}
 # Disable dead-end-checks for unaccessible oneways
-highway=* & oneway=yes & (access=private|access=no) {add mkgmap:dead-end-check=false}
+highway=* & oneway=yes & (access=private | access=no) {add mkgmap:dead-end-check=false}
 # Validation-like checks (uncomment to enable)
 #highway=motorway_link & oneway!=yes & oneway!=no {echo "motorway_link lacks oneway"}
 highway=motorway | highway=motorway_link {add oneway=yes; add mkgmap:numbers=false}
@@ -51,21 +51,20 @@
 # motorway_link, trunk_link, primary_link, secondary_link, tertiary_link
 # build destination hint
 mkgmap:dest_hint=* {
-    set dest_hint='${destination:ref|subst: =>} ${mkgmap:dest_hint|subst:;=> |subst:/=> }' |
-                  '${ref|subst: =>} ${mkgmap:dest_hint|subst:;=> |subst:/=> }' |
-                  '${mkgmap:dest_hint|subst:;=> |subst:/=> }';
+    set tmp:dest_hint='${destination:ref|subst: =>} ${mkgmap:dest_hint|subst:;=> |subst:/=> }' |
+                      '${ref|subst: =>} ${mkgmap:dest_hint|subst:;=> |subst:/=> }' |
+                      '${mkgmap:dest_hint|subst:;=> |subst:/=> }';
     }
 # build exit hint
 mkgmap:exit_hint=true {
-    set exit_hint='Exit ${mkgmap:exit_hint_ref} ${mkgmap:exit_hint_name}' |
-                  'Exit ${mkgmap:exit_hint_ref} ${mkgmap:exit_hint_exit_to}' |
-                  'Exit ${mkgmap:exit_hint_exit_to}' |
-                  'Exit ${mkgmap:exit_hint_name}' |
-                  'Exit ${mkgmap:exit_hint_ref}';
+    set tmp:exit_hint='Exit ${mkgmap:exit_hint_ref} ${mkgmap:exit_hint_name}' |
+                      'Exit ${mkgmap:exit_hint_ref} ${mkgmap:exit_hint_exit_to}' |
+                      'Exit ${mkgmap:exit_hint_exit_to}' |
+                      'Exit ${mkgmap:exit_hint_name}' |
+                      'Exit ${mkgmap:exit_hint_ref}';
     }
-
 # use destination hint and/or exit hint to build name
-(mkgmap:exit_hint=true | mkgmap:dest_hint=*) {name '${exit_hint} ${dest_hint}' | '${dest_hint}' | '${exit_hint}'}
+mkgmap:exit_hint=true | mkgmap:dest_hint=* {name '${tmp:exit_hint} ${tmp:dest_hint}' | '${tmp:dest_hint}' | '${tmp:exit_hint}'}
 # end of rules for process-exits and process-destination options
 
 # Flag paved roads
@@ -100,11 +99,11 @@
     {set mkgmap:road-class=-2; set mkgmap:road-speed=-2; delete mkgmap:fast_road}
 
 # Convert generic path to most specific
-highway=footway & snowplowing!=no & (bicycle=yes|bicycle=designated|bicycle=permissive|bicycle=official)
+highway=footway & snowplowing!=no & (bicycle=yes | bicycle=designated | bicycle=permissive | bicycle=official)
     {set highway=cycleway; set bicycle=yes; set foot=yes}
-highway=path & snowplowing!=no & (bicycle=designated|bicycle=permissive|bicycle=official)
+highway=path & snowplowing!=no & (bicycle=designated | bicycle=permissive | bicycle=official)
     {set highway=cycleway; set bicycle=yes}
-highway=path & (horse=designated|horse=permissive|horse=official)
+highway=path & (horse=designated | horse=permissive | horse=official)
     {set highway=bridleway; set horse=yes}
 
 leisure=track & area!=yes {add highway=footway; name '${name} (${sport})' | '${name}'}
@@ -213,9 +212,10 @@
 boundary=national [0x1e resolution 17]
 boundary=political [0x1c resolution 19]
 
-route=ferry {set mkgmap:numbers=false}
-route=ferry & (motorcar=no | motor_vehicle=no) {add mkgmap:ferry=1} [0x1b road_class=0 road_speed=0 resolution 23]
-route=ferry {add mkgmap:ferry=1} [0x1b road_class=3 road_speed=0 resolution 19]
+route=ferry & (toll=no | toll=false) {set mkgmap:toll=no}
+route=ferry {set mkgmap:numbers=false; set mkgmap:ferry=1; add mkgmap:toll=yes}
+route=ferry & (motorcar=no | motor_vehicle=no) [0x1b road_class=0 road_speed=0 resolution 23]
+route=ferry [0x1b road_class=3 road_speed=0 resolution 19]
 
 (waterway=river | waterway=canal) & intermittent=yes [0x26 resolution 20]
 (waterway=stream | waterway=drain) & intermittent=yes [0x10A02 resolution 22]
Index: resources/styles/default/points
===================================================================
--- resources/styles/default/points	(revision 4255)
+++ resources/styles/default/points	(working copy)
@@ -46,7 +46,8 @@
     }
 
 internet_access=yes {name 'Internet ${name}' | 'Internet'} [0x2f12 resolution 24 continue]
-internet_access=* & internet_access!=no & internet_access!=yes {name 'Internet(${internet_access}) ${name|def:}'} [0x2f12 resolution 24 continue]
+internet_access=* & internet_access!=no & internet_access!=yes
+    {name 'Internet(${internet_access}) ${name}' | 'Internet(${internet_access})'} [0x2f12 resolution 24 continue]
 
 (public_transport=platform | highway=bus_stop | railway=tram_stop | railway=halt | railway=station)
     & (ref=* | route_ref=*)
@@ -63,31 +64,31 @@
 
 include 'inc/name';
 
-place=city & population > 999999 &               name=* {set cityxx=yes} [0x0100 resolution 12 continue with_actions]
-place=city & population > 799999 & cityxx!=yes & name=* {set cityxx=yes} [0x0200 resolution 14 continue with_actions]
-place=city & population > 399999 & cityxx!=yes & name=* {set cityxx=yes} [0x0300 resolution 15 continue with_actions]
-place=city & population > 299999 & cityxx!=yes & name=* {set cityxx=yes} [0x0400 resolution 16 continue with_actions]
-place=city & population > 199999 & cityxx!=yes & name=* {set cityxx=yes} [0x0500 resolution 16 continue with_actions]
-place=city & population >  99999 & cityxx!=yes & name=* {set cityxx=yes} [0x0600 resolution 17 continue with_actions]
-place=city & population >  49999 & cityxx!=yes & name=* {set cityxx=yes} [0x0700 resolution 17 continue with_actions]
-place=city & population >   9999 & cityxx!=yes & name=* {set cityxx=yes} [0x0800 resolution 18 continue with_actions]
+place=city & population > 999999 &                 name=* {set tmp:city=yes} [0x0100 resolution 12 continue with_actions]
+place=city & population > 799999 & tmp:city!=yes & name=* {set tmp:city=yes} [0x0200 resolution 14 continue with_actions]
+place=city & population > 399999 & tmp:city!=yes & name=* {set tmp:city=yes} [0x0300 resolution 15 continue with_actions]
+place=city & population > 299999 & tmp:city!=yes & name=* {set tmp:city=yes} [0x0400 resolution 16 continue with_actions]
+place=city & population > 199999 & tmp:city!=yes & name=* {set tmp:city=yes} [0x0500 resolution 16 continue with_actions]
+place=city & population >  99999 & tmp:city!=yes & name=* {set tmp:city=yes} [0x0600 resolution 17 continue with_actions]
+place=city & population >  49999 & tmp:city!=yes & name=* {set tmp:city=yes} [0x0700 resolution 17 continue with_actions]
+place=city & population >   9999 & tmp:city!=yes & name=* {set tmp:city=yes} [0x0800 resolution 18 continue with_actions]
 
-place=city & population >      0 & cityxx!=yes & name=* {set cityxx=yes} [0x0800 resolution 18 continue with_actions]
-place=city                       & cityxx!=yes & name=* {set cityxx=yes} [0x0700 resolution 18 continue with_actions]
+place=city & population >      0 & tmp:city!=yes & name=* {set tmp:city=yes} [0x0800 resolution 18 continue with_actions]
+place=city                       & tmp:city!=yes & name=* {set tmp:city=yes} [0x0700 resolution 18 continue with_actions]
 
-place=town & population >  69999 & cityxx!=yes & name=* {set cityxx=yes} [0x0600 resolution 17 continue with_actions]
-place=town & population >  19999 & cityxx!=yes & name=* {set cityxx=yes} [0x0700 resolution 18 continue with_actions]
-place=town & population >   9999 & cityxx!=yes & name=* {set cityxx=yes} [0x0800 resolution 19 continue with_actions]
-place=town & population >   4999 & cityxx!=yes & name=* {set cityxx=yes} [0x0900 resolution 19 continue with_actions]
-place=town & population >    999 & cityxx!=yes & name=* {set cityxx=yes} [0x0a00 resolution 19 continue with_actions]
-place=town & population >      0 & cityxx!=yes & name=* {set cityxx=yes} [0x0b00 resolution 20 continue with_actions]
-place=town                       & cityxx!=yes & name=* {set cityxx=yes} [0x0800 resolution 19 continue with_actions]
+place=town & population >  69999 & tmp:city!=yes & name=* {set tmp:city=yes} [0x0600 resolution 17 continue with_actions]
+place=town & population >  19999 & tmp:city!=yes & name=* {set tmp:city=yes} [0x0700 resolution 18 continue with_actions]
+place=town & population >   9999 & tmp:city!=yes & name=* {set tmp:city=yes} [0x0800 resolution 19 continue with_actions]
+place=town & population >   4999 & tmp:city!=yes & name=* {set tmp:city=yes} [0x0900 resolution 19 continue with_actions]
+place=town & population >    999 & tmp:city!=yes & name=* {set tmp:city=yes} [0x0a00 resolution 19 continue with_actions]
+place=town & population >      0 & tmp:city!=yes & name=* {set tmp:city=yes} [0x0b00 resolution 20 continue with_actions]
+place=town                       & tmp:city!=yes & name=* {set tmp:city=yes} [0x0800 resolution 19 continue with_actions]
 
-place=island                     & cityxx!=yes          {set cityxx=yes} [0x650c resolution 20 continue with_actions]
-place=islet                      & cityxx!=yes          {set cityxx=yes} [0x650c resolution 22 continue with_actions]
-place=village                    & cityxx!=yes          {set cityxx=yes} [0x0900 resolution 22 continue with_actions]
-place=suburb                     & cityxx!=yes          {set cityxx=yes} [0x0a00 resolution 22 continue with_actions]
-place=hamlet                     & cityxx!=yes          {set cityxx=yes} [0x0b00 resolution 24 continue with_actions]
+place=island                     & tmp:city!=yes          {set tmp:city=yes} [0x650c resolution 20 continue with_actions]
+place=islet                      & tmp:city!=yes          {set tmp:city=yes} [0x650c resolution 22 continue with_actions]
+place=village                    & tmp:city!=yes          {set tmp:city=yes} [0x0900 resolution 22 continue with_actions]
+place=suburb                     & tmp:city!=yes          {set tmp:city=yes} [0x0a00 resolution 22 continue with_actions]
+place=hamlet                     & tmp:city!=yes          {set tmp:city=yes} [0x0b00 resolution 24 continue with_actions]
 
 #aeroway=airport [0x5900 resolution 22]
 aeroway=airport [0x2f04 resolution 22]
@@ -108,6 +109,7 @@
 amenity=car_sharing [0x2f02 resolution 24]
 amenity=car_wash [0x2f0e resolution 24]
 amenity=casino [0x2d04 resolution 24]
+amenity=charging_station [0x2f01 resolution 24 default_name 'Car charging']
 amenity=cinema [0x2d03 resolution 24]
 amenity=college [0x2c05 resolution 24]
 amenity=concert_hall [0x2c09 resolution 24]
@@ -117,18 +119,22 @@
 amenity=community_center [0x3005 resolution 24]
 amenity=courthouse [0x3004 resolution 24]
 amenity=drinking_water [0x5000 resolution 24 default_name 'Water']
-amenity=embassy & country=* {set name='${country} ${name|def:}'} [0x3003 resolution 24]
+amenity=embassy & country=* {set name='${country} ${name|def:Embassy}'} [0x3003 resolution 24]
 amenity=embassy & country!=* [0x3003 resolution 24 default_name 'Embassy']
 amenity=emergency_phone [0x2f12 resolution 24 default_name 'Emergency Phone']
 amenity=ferry_terminal [0x2f08 resolution 22]
+
 amenity=fast_food & cuisine=grill [0x2a03 resolution 24]
-amenity=fast_food & cuisine ~ '.*pizza.*' [0x2a0a resolution 24]
+amenity=fast_food & cuisine~'.*pizza.*' [0x2a0a resolution 24]
+amenity=fast_food & cuisine=* {add name='${cuisine|subst:"_=> "}'} [0x2a07 resolution 24]
 amenity=fast_food [0x2a07 resolution 24]
+
 amenity=fire_station [0x3008 resolution 24]
 amenity=food_court [0x2a13 resolution 24]
 amenity=fuel & fuel:HGV_diesel=yes [0x2f16 resolution 23]
 amenity=fuel & shop=convenience [0x2e06 resolution 24]
 amenity=fuel [0x2f01 resolution 24]
+amenity=grave_yard | amenity=crematorium [0x6403 resolution 24]
 amenity=kindergarten [0x2c05 resolution 24]
 amenity=library [0x2c03 resolution 24]
 amenity=nightclub [0x2d02 resolution 24]
@@ -137,22 +143,26 @@
 amenity=pharmacy [0x2e05 resolution 24]
 amenity=place_of_worship [0x2c0b resolution 24]
 amenity=police [0x3001 resolution 24]
+amenity=post_box [0x2f15 resolution 24 default_name 'Post box']
 amenity=post_office [0x2f05 resolution 24]
-amenity=prison [0x3007 resolution 24]
+amenity=prison [0x3007 resolution 24 default_name 'Prison']
 amenity=pub [0x2d02 resolution 24]
 amenity=public_building [0x3007 resolution 24]
-amenity=recycling [0x2f15 resolution 24]
+amenity=recycling [0x2f15 resolution 24 default_name 'Recycling']
+
 amenity=restaurant & cuisine=american [0x2a01 resolution 24]
 amenity=restaurant & cuisine=asian [0x2a02 resolution 24]
 amenity=restaurant & cuisine=bagel [0x2a0d resolution 24]
 amenity=restaurant & cuisine=barbecue [0x2a03 resolution 24]
 amenity=restaurant & cuisine=british [0x2a11 resolution 24]
-amenity=restaurant & cuisine='cafe/diner' [0x2a0e resolution 24]
 amenity=restaurant & cuisine=chinese [0x2a04 resolution 24]
+amenity=restaurant & cuisine=curry [0x2a02 resolution 24]
 amenity=restaurant & cuisine=deli [0x2a05 resolution 24]
 amenity=restaurant & cuisine=french [0x2a0f resolution 24]
+amenity=restaurant & cuisine=fish_and_chips [0x2a11 resolution 24]
 amenity=restaurant & (cuisine=german | cuisine=bavarian) [0x2a10 resolution 24]
 amenity=restaurant & cuisine=grill [0x2a03 resolution 24]
+amenity=restaurant & cuisine=indian [0x2a02 resolution 24]
 amenity=restaurant & cuisine=international [0x2a06 resolution 24]
 amenity=restaurant & cuisine=italian [0x2a08 resolution 24]
 amenity=restaurant & cuisine=japanese [0x2a02 resolution 24]
@@ -160,12 +170,15 @@
 amenity=restaurant & cuisine=mexican [0x2a09 resolution 24]
 amenity=restaurant & cuisine~'.*pizza.*' [0x2a0a resolution 24]
 amenity=restaurant & cuisine=sea_food [0x2a0b resolution 24]
+# often "seafood" is used instead of official tag "sea_food"
+amenity=restaurant & cuisine=seafood [0x2a0b resolution 24]
 amenity=restaurant & cuisine=spanish [0x2a09 resolution 24]
 amenity=restaurant & cuisine=speciality [0x2a12 resolution 24]
 amenity=restaurant & cuisine=steak [0x2a0c resolution 24]
 amenity=restaurant & cuisine=thai [0x2a02 resolution 24]
-amenity=restaurant & cuisine=* [0x2a13 resolution 24]
+amenity=restaurant & cuisine=* {add name='${cuisine|subst:"_=> "}'} [0x2a13 resolution 24]
 amenity=restaurant [0x2a00 resolution 24]
+
 amenity=school [0x2c05 resolution 24]
 # amenity=shelter is ambiguous; when possible, consider using other tags:
 #  tourism=lean_to or tourism=picnic_site
@@ -205,10 +218,11 @@
 leisure=nature_reserve & name=* [0x6612 resolution 24]
 leisure=park [0x2c06 resolution 24]
 leisure=pitch {name '${name} (${sport})' | '${name}'} [0x2c08 resolution 24]
-leisure=playground [0x2c06 resolution 24]
-leisure=recreation_ground [0x2c08 resolution 24]
+leisure=playground [0x2c06 resolution 24 default_name 'Playground']
+leisure=recreation_ground [0x2c08 resolution 24 default_name 'Rec.']
 leisure=sports_center | leisure=sports_centre {name '${name} (${sport})' | '${name}'} [0x2d0a resolution 24]
 leisure=stadium {name '${name} (${sport})' | '${name}'} [0x2c08 resolution 24]
+leisure=swimming_pool [0x2d09 resolution 24]
 leisure=track {name '${name} (${sport})' | '${name}'} [0x2c08 resolution 24]
 leisure=water_park [0x2d09 resolution 24]
 
@@ -257,7 +271,7 @@
 shop=supermarket [0x2e02 resolution 24]
 shop=tires [0x2f07 resolution 24]
 shop=tyres [0x2f07 resolution 24]
-shop=* & shop!=no & shop!=none [0x2e0c resolution 24]
+shop=* & shop!=no & shop!=none {add name='${shop|subst:"_=> "}'} [0x2e0c resolution 24]
 
 sport=9pin [0x2d07 resolution 24]
 sport=10pin | leisure=bowling_alley [0x2d07 resolution 24]
@@ -272,6 +286,7 @@
 tourism=attraction [0x2c04 resolution 24]
 tourism=artwork [0x2c04 resolution 24]
 tourism=aquarium [0x2c07 resolution 24]
+tourism=bed_and_breakfast [0x2b02 resolution 24]
 tourism=camp_site [0x2b05 resolution 24]
 tourism=caravan_site [0x2b05 resolution 24]
 tourism=chalet [0x2b02 resolution 24]
@@ -288,11 +303,13 @@
 tourism=viewpoint {name '${name} - ${description}' | '${name}'} [0x2c04 resolution 24]
 tourism=wine_cellar [0x2c0a resolution 24]
 tourism=zoo [0x2c07 resolution 24]
+tourism=* & tourism!=yes & tourism!=no {add name='${tourism|subst:"_=> "}'}
+tourism=* & tourism!=no [0x2c0d resolution 24]
 
 barrier=bollard | barrier=bus_trap | barrier=gate [0x660f resolution 24]
 barrier=block | barrier=cycle_barrier | barrier=stile | barrier=kissing_gate [0x660f resolution 24]
 
-landuse=basin|landuse=reservoir [0x650f resolution 24]
+landuse=basin | landuse=reservoir [0x650f resolution 24]
 
 natural=beach [0x6604 resolution 24]
 natural=glacier [0x650a resolution 24]
Index: resources/styles/default/polygons
===================================================================
--- resources/styles/default/polygons	(revision 4255)
+++ resources/styles/default/polygons	(working copy)
@@ -18,7 +18,7 @@
 aeroway=airport [0x07 resolution 20]
 aeroway=aerodrome [0x07 resolution 20]
 aeroway=runway {name '${ref}'} [0x0e resolution 20]
-(aeroway=taxiway | aeroway=taxilane) {name '${ref}'} [0x0e resolution 24]
+aeroway=taxiway | aeroway=taxilane {name '${ref}'} [0x0e resolution 24]
 aeroway=heliport [0x07 resolution 20]
 aeroway=helipad [0x0e resolution 22]
 
@@ -52,7 +52,7 @@
 
 place=village [0x03 resolution 19]
 
-shop=* [0x08 resolution 22]
+shop=* {add name='${shop|subst:"_=> "}'} [0x08 resolution 22]
 
 # squares and plazas
 highway=pedestrian & (area=yes | mkgmap:mp_created=true) [0x17 resolution 22]
@@ -63,7 +63,7 @@
 historic=archaeological_site | historic=ruins [0x1e resolution 21]
 
 landuse=basin [0x3f resolution 20]
-(landuse=reservoir | (natural=water & water=reservoir)) [0x3f resolution 20]
+landuse=reservoir | (natural=water & water=reservoir) [0x3f resolution 20]
 
 natural=bay [0x3d resolution 18]
 natural=glacier [0x4d resolution 18]
@@ -77,12 +77,12 @@
 waterway=riverbank [0x46 resolution 20]
 
 landuse=allotments [0x4e resolution 21]
-landuse=cemetery|landuse=cemetary|amenity=grave_yard [0x1a resolution 21]
+landuse=cemetery | landuse=cemetary | amenity=grave_yard [0x1a resolution 21]
 landuse=commercial [0x0c resolution 19]
 landuse=construction [0x0c resolution 21]
-landuse=farm |landuse=farmland [0x4e resolution 20]
+landuse=farm | landuse=farmland [0x4e resolution 20]
 landuse=farmyard [0x10 resolution 22]
-landuse=forest|landuse=wood [0x50 resolution 20]
+landuse=forest | landuse=wood [0x50 resolution 20]
 landuse=greenfield [0x17 resolution 20]
 landuse=meadow | landuse=grass [0x17 resolution 19]
 landuse=military [0x04 resolution 19]
@@ -89,9 +89,9 @@
 landuse=quarry [0x0c resolution 19]
 landuse=recreation_ground [0x19 resolution 19]
 # dedicate resolution 24 for building=* instead of related landuse=*
-landuse=industrial [0x0c resolution 23-19]
-landuse=residential [0x10 resolution 23-19]
-landuse=retail [0x08 resolution 23-20]
+landuse=industrial [0x0c resolution 19-23]
+landuse=residential [0x10 resolution 19-23]
+landuse=retail [0x08 resolution 20-23]
 landuse=village_green [0x17 resolution 20]
 landuse=vineyard [0x4e resolution 20]
 landuse=orchard [0x4e resolution 20]
@@ -105,15 +105,17 @@
 natural=wood [0x50 resolution 20]
 
 # building tag should be last
-(building=* | amenity=*) & area!=no & amenity!=grave_yard [0x13 resolution 24]
-tourism=* & area!=no & waterway!=* [0x1f resolution 24]
+amenity=* & area!=no & amenity!=grave_yard {add name='${amenity|subst:"_=> "}'} [0x13 resolution 24]
+building=* & building!=no [0x13 resolution 24]
+tourism=* & area!=no & waterway!=* {add name='${tourism|subst:"_=> "}'} [0x1f resolution 24]
+
 # man_made can be used on areas or lines
 man_made=* & area!=no & (
     man_made!=door & man_made!=embankment & man_made!=breakwater & man_made!=cable_line & man_made!=cutline &
     man_made!=cutting & man_made!=levee & man_made!=trench & man_made!=groyne & man_made!=reinforced_slope)
-    [0x13 resolution 24]
+    {add name='${man_made|subst:"_=> "}'} [0x13 resolution 24]
 
-man_made=* & area=yes [0x13 resolution 24]
+man_made=* & area=yes {add name='${man_made|subst:"_=> "}'} [0x13 resolution 24]
 
 # render small named islands
 place=island & name=* & area_size() < 1000000 [0x53 resolution 19]
@@ -122,7 +124,7 @@
 <finalize>
 # The finalizer section is executed for each element when a rule with an element type matches
 
-# we need addrees info from buildings for the address search
+# we need address info from buildings for the address search
 include 'inc/address';
 
 name=* {name '${name}'}